#ifndef MSP_IO_MEMORY_H_
#define MSP_IO_MEMORY_H_

#include "seekable.h"

namespace Msp {
namespace IO {

class Memory: public Seekable
{
private:
	char *begin;
	char *end;
	char *pos;

public:
	Memory(char *, unsigned, Mode = M_RDWR);
	Memory(char *, char *, Mode = M_RDWR);
	Memory(const char *, unsigned);
	Memory(const char *, const char *);
private:
	void init(char *, char *, Mode);

	virtual unsigned do_write(const char *, unsigned);
	virtual unsigned do_read(char *, unsigned);
public:
	virtual unsigned put(char);
	virtual bool getline(std::string &);
	virtual int get();

	virtual SeekOffset seek(SeekOffset, SeekType);
	virtual SeekOffset tell() const { return pos-begin; }
};

} // namespace IO
} // namespace Msp

#endif
